//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 11: Anwendung von Filterfunktionen
//
// Datei:  ImageViewer.cpp
// Inhalt: Klasse ImageViewer zum oeffnen, speicher, und zum Darstellen von Bildern
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <QtCore/QString>
#include <QtGui/QtGui>
#include <QtGui/QColor>
#include "ImageViewer.h"
using namespace std;

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
char ImageViewer::count = '1';

//////////////////////////////////////////////////////////////////////////////
ImageViewer::ImageViewer()
{
	label = new QLabel;
	label->setBackgroundRole(QPalette::Base);
	
	setCentralWidget(label);
	
	QString name = "Image Viewer ";
	setWindowTitle(name+ count++);
	
	resize(500, 400);
	show();	
}

//////////////////////////////////////////////////////////////////////////////
ImageViewer::ImageViewer(QImage* neuesImage)
{
	label = new QLabel;
	label->setBackgroundRole(QPalette::Base);
	
	setCentralWidget(label);
		
	QString name = "Image Viewer ";
	setWindowTitle(name + count++);
		
	image = neuesImage;
	label->setPixmap(QPixmap::fromImage(*image ));
	label->adjustSize();
	
	resize(image->width(), image->height());
	show();
}

//////////////////////////////////////////////////////////////////////////////
void ImageViewer::open()
{	
	image = new QImage;
	QString fileName = QFileDialog::getOpenFileName(this,"Datei ffnen", QDir::currentPath());
	if (!fileName.isEmpty()) {
		image->load(fileName);
		if (image->isNull()) {
			QMessageBox::information(this,"Image Viewer",tr("Cannot load %1.").arg(fileName));
			return;
		}
		label->setPixmap(QPixmap::fromImage(*image));
		label->adjustSize();
	}
	resize(image->width(),image->height());
}

//////////////////////////////////////////////////////////////////////////////
void ImageViewer::save()
{
	QString fileName = QFileDialog::getSaveFileName(this,"Datei speichern", QDir::currentPath(),"Bilddateien (*.png *.bmp)" );
	
	if ( !fileName.isEmpty() )
	{
		image->save(fileName);
	}
}

//////////////////////////////////////////////////////////////////////////////
QImage* ImageViewer::getImage()
{
	return image;
}

//////////////////////////////////////////////////////////////////////////////
void ImageViewer::setImage(QImage* neu)
{
	image = neu;
	label->setPixmap(QPixmap::fromImage(*image));
	label->adjustSize();
	resize(image->width(),image->height());
}
