//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 10: Einfuehrung in die Programmierung grafischer Benutzeroberflaechen
//
// Datei:  main.cpp
// Inhalt: Hauptprogramm
//////////////////////////////////////////////////////////////////////////////
#include <iostream>
#include <QtGui/QApplication>
#include <QtGui/qpushbutton.h>
using namespace std;

#include "ImageViewer.h"

void durchstreichen(QImage & im)
{
	int width = im.width();
	int height = im.height();
	
	QRgb value;
	value = qRgb(0xff, 0, 0);
	
	double steigung = (double)width/height;
	
	for (int n=0; n < width; ++n)
	{
		for (int i=0; i < 5; ++i)
		{
			im.setPixel(n*steigung+i, n, value);
		}
	}
}

void einrahmen(QImage * im)
{
	QImage * tempIm = new QImage(im->copy());
	
	delete im;
	im = new QImage(tempIm->width()+40, tempIm->height()+40, QImage::Format_RGB32);
	im->fill(qRgb(0xff, 0, 0));
	
	
	for (int i=0; i < tempIm->width(); ++i)
	{
		for (int n=0; n < tempIm->height(); ++n)
		{
			im->setPixel(20+i, 20+n, tempIm->pixel(i, n));
		}
	}
	

	delete tempIm;
}

int main(int argc, char *argv[])
{
	QApplication app(argc, argv);
	
	ImageViewer imView;
	imView.open();
	
	QImage * imCpy = new QImage(imView.getImage()->copy(
				0,0, 
				imView.getImage()->width(), 
				imView.getImage()->height()));
	
	einrahmen(imCpy);	

	ImageViewer cpyView(imCpy);	
	cpyView.save();
	
	return app.exec();
}
