//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 11: Anwendung von Filterfunktionen
//
// Datei:  EdgeDetector.h
// Inhalt: Klasse EdgeDetector zur Detektierung von Kanten in Farb-/Graubildern
//////////////////////////////////////////////////////////////////////////////

#ifndef EDGEDETECTOR_H_
#define EDGEDETECTOR_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Matrix3x3.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// CLASS DECLARATION //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

class EdgeDetector
	{
		
	public:
		EdgeDetector();
		
		void setFilter(Matrix3x3 m);
		void transposeMatrix();
		void applyFilter(QImage * in, QImage * out);
		void applyFilterBothDirections(QImage * in, QImage * out, int doNorm=1);
		void setScaleFactor(double newFactor);
		
	private:
		
		Matrix3x3 filter;
		double scalFactor;
	};



#endif /*EDGEDETECTOR_H_*/
