//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 11: Anwendung von Filterfunktionen
//
// Datei:  main.cpp
// Inhalt: Hauptprogramm
//////////////////////////////////////////////////////////////////////////////
#include <iostream>
#include <QtGui/QApplication>
using namespace std;

#include "ImageViewer.h"
#include "EdgeDetector.h"
#include "Matrix3x3.h"

int main(int argc, char *argv[])
{
	QApplication app(argc, argv);
	
	ImageViewer imView;
	imView.open();
	
	QImage original = imView.getImage()->copy();
	
	QImage filtered(original.width(), original.height(), QImage::Format_RGB32);
	
	EdgeDetector edgeDet;
	
	cin.clear();
	
	char auswahl;
	
	cout << "Bitte wählen Sie ein Filter:" << endl
	<< "1.) Sobel" << endl
	<< "2.) Prewitt" << endl
	<< "3.) Laplace" << endl << flush;
	cin >> auswahl;
	
	Matrix3x3 filter;
	
	switch (auswahl) {
			default:
				cout << "Ungültige Auswahl. Belasse den Standardfilter.";
			case '1':
				filter.setMatrix(
												 1, 0, -1, 
												 2, 0, -2, 
												 1, 0, -1);
				break;
			case '2':
				filter.setMatrix(
												 1, 0, -1, 
												 1, 0, -1, 
												 1, 0, -1);
				break;
			case '3':
				filter.setMatrix(
												 -1, -1, -1, 
												 -1, 8, -1, 
												 -1, -1, -1);
				break;
	}
	
	
	cout << "Wünschen Sie eine transponierte Anwendung der Matrix? ([j]a/[n]ein/[b]eides)" << endl << flush;
	cin >> auswahl;
	
	switch (auswahl)
	{
			case 'b':
				edgeDet.setFilter(filter);
				
				cout << "Wünschen sie eine Normierung der Pixelwerte? ([j]a/[n]ein)" << endl << flush;
				cin >> auswahl;
				
				if ('j' == auswahl)
				{
					edgeDet.applyFilterBothDirections(&original, &filtered, TRUE);
				}
				else
				{
					edgeDet.applyFilterBothDirections(&original, &filtered, FALSE);
				}
				break;
			case 'j':
				filter = filter.transpose();
			default:
				edgeDet.setFilter(filter);
				edgeDet.applyFilter(&original, &filtered);
				break;
	}
	
	ImageViewer filteredView(&filtered);
	filteredView.save();
	
	return app.exec();
}
