// Praktikum Angewandte Informatik
// Reversi

// Defines



#include <iostream>
#include "reversi.h"
#include "Reversi_KI.h"

using namespace std;

void spielfeld_anzeigen(int spielfeld[SIZE_X][SIZE_Y])
{
  cout << "  ";

  for (int j=65;j<65+SIZE_Y;j++)
  {
    cout << ((char) j) << " " ;
  }
  cout <<  endl;
  for (int i=0;i<SIZE_X;i++)
  {
    cout << i+1;

    for (int j=0;j<SIZE_Y;j++)
    {
      switch (spielfeld[j][i])
      {
      case 0:
        cout << "  " ;
        break;

      case 1:
        cout << " X";
        break;

      case 2:
        cout << " O";
        break;

      default:
        cout << "Inconsistent data in field!" << endl;
        cout << "Aborting .... " << endl;
        exit(0);
        break;
      }
    };//for j

    cout << endl;
  }//for i

}

int gewinner(int spielfeld[SIZE_X][SIZE_Y])
{
  int count[3];

  for (int i=0;i<SIZE_X; i++)
  {
    for (int j=0;j<SIZE_Y; j++)
    {
      ++count[spielfeld[j][i]-1];
    }
  }
  if (count[0] == count[1])
  {
    return 0;
  }
  if (count[1] > count[0])
  {
    return 2;
  }
  else
  {
    return 1;
  }
}


bool zug_gueltig(int spielfeld[SIZE_X][SIZE_Y], int spieler, int pos_x, int pos_y)
{
  // Process all possible directions
  int gegner=-(spieler -2) + 1;// the same as: if spieler=1 -> spieler=2 else
  // if spieler=2 -> spieler=1

  if (spielfeld[pos_x][pos_y]!=0)//check if field is currently empty
  {
    return false;
  }

  for (int i=-1;i<=1;i++)
  {
    for (int j=-1;j<=1;j++)
    {
      if (0 == i && 0 == j) continue;

      int cur_x=pos_x;
      int cur_y=pos_y;
      int aroundEnemy=0;

      while ((cur_x+=j) >= 0 && cur_x < SIZE_X &&
             (cur_y+=i) >= 0 && cur_y < SIZE_Y)
      {
        if (spielfeld[cur_x][cur_y] == gegner)
        {
          aroundEnemy=1;
        }
        else if (aroundEnemy && spielfeld[cur_x][cur_y] == spieler)
        {
          return true;
        }
        else
        {
          break;
        }
      }
    }
  }
  return false;
}

bool zug_ausfuehren(int spielfeld[SIZE_X][SIZE_Y], int spieler, int pos_x, int pos_y)
{
  int gegner=-(spieler -2) + 1;


  for (int i=-1;i<=1;i++)
  {
    for (int j=-1;j<=1;j++)
    {
      int cur_x = pos_x;
      int cur_y = pos_y;
      int aroundEnemy=0;

      while((cur_x+=j) >= 0 && cur_x < SIZE_X &&
          (cur_y+=i) >= 0 && cur_y < SIZE_Y)
      {
        // Wir befinden uns noch auf dem Spielfeld
        if (spielfeld[cur_x][cur_y] == spieler && aroundEnemy)
        {
          int rev_x=cur_x;
          int rev_y=cur_y;

          do{
            rev_x-=j;
            rev_y-=i;

            if (rev_x == pos_x && rev_y == pos_y) break;

            spielfeld[rev_x][rev_y] = spieler;
          }while(1);
          // Funktion abbrechen. Jetzt darf nichts mehr getan werden,
          // da der Zug vorbei ist.
          spielfeld[pos_x][pos_y] = spieler;
          return true;
        }
        else if (spielfeld[cur_x][cur_y] == gegner)
        {
          aroundEnemy = 1;
        }
        else
        { // Ein freies Feld darf nicht mehr vorkommen, also abbrechen
          break;
        }
      }
    }
  }
  return false;
}

int moegliche_zuege(int spielfeld[SIZE_X][SIZE_Y], int spieler)
{
  int possibilities=0;
  for (int i=0;i<SIZE_X; i++)
  {
    for (int j=0;j<SIZE_Y; j++)
    {
      if (spielfeld[j][i] == 0)
      {
        if (zug_gueltig(spielfeld, spieler, j, i))
          ++possibilities;
      }
    }
  }
  return possibilities;
}

bool mensch_zug(int spielfeld[SIZE_X][SIZE_Y], int spieler)
{
  if (moegliche_zuege(spielfeld,spieler)==0)
  {
    return false;
  }
  int px;
  int py;
  bool repeat=false;

  do
  {
    if (repeat)
    {
      cout << endl << "Invalid input !" << endl;
    }
    string eingabe;
    eingabe.reserve(50);
    cout << endl << "Your move (e.g. A1): " ;
    eingabe.erase(eingabe.begin(),eingabe.end());
    cin >> eingabe;
    px = ((int) eingabe.at(0) ) - 65;
    py = ((int) eingabe.at(1) ) - 49;
  }
  while (repeat=!zug_gueltig(spielfeld,spieler,px,py));
  zug_ausfuehren(spielfeld,spieler,px,py);
  return true;
}


void Spiel(int spielertyp[2])
{
  int spielfeld[SIZE_X][SIZE_Y]={
      {0,0,0,0,0,0,0,0},
      {0,0,0,0,0,0,0,0},
      {0,0,0,0,0,0,0,0},
      {0,0,0,1,2,0,0,0},
      {0,0,0,2,1,0,0,0},
      {0,0,0,0,0,0,0,0},
      {0,0,0,0,0,0,0,0},
      {0,0,0,0,0,0,0,0}};


  int aktueller_spieler=1;
  spielfeld_anzeigen(spielfeld);

  do{
    cout << "Spieler Nr. " << aktueller_spieler << " ist an der Reihe!" << endl;
    if (spielertyp[aktueller_spieler-1] == 1)
    {
      cout << "Menschenzug!" << endl;
      mensch_zug(spielfeld, aktueller_spieler);
    }
    else
    {
      cout << "Computerzug!" << endl;
      computer_zug(spielfeld, aktueller_spieler);
    }
    cout << endl;
    spielfeld_anzeigen(spielfeld);
    aktueller_spieler = 1 -aktueller_spieler +2;
    cout << "Mögliche Züge für Spieler " << aktueller_spieler << ": "
         << moegliche_zuege(spielfeld,aktueller_spieler) << endl;
  } while (moegliche_zuege(spielfeld,aktueller_spieler) != 0);
  // HIER STECKT DER FEHLER

  switch (gewinner(spielfeld))
  {
  case 1:
    cout << "Bravo, Spieler eins hat gewonnen!" << endl;
    break;
  case 2:
    cout << "Hurra, Spieler zwei hat gewonnen!" << endl;
    break;
  }
}


int main(void)
{
  char input;
  string contrahentTypes[] = {"Mensch", "Maschine"};
  int typ[2] = { 2, 2 };

  do
  {
    for (int n=1; n <= 2; ++n)
    {
      cout << "Bitte geben Sie den Typ des " << n << ". Spielers an: ([C]omputer / [M]ensch): ";
      cin >> input;
      switch (input)
      {
      case 'c':
      case 'C':
        typ[n-1] = 2;
        break;
      case 'm':
      case 'M':
        typ[n-1] = 1;
        break;
      }
    }

    cout << "Es treten an: " << contrahentTypes[typ[0] -1] << " gegen "
         << contrahentTypes[typ[1] -1] << "!" << endl;

    Spiel(typ);

    cout << "Haben Sie Lust auf eine weitere Runde? (j/n)";
    cin >> input;
  } while (input == 'j' || input == 'J');

  return 0;
}
