//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 5: Dynamische Datenstrukturen
//
// Datei:  Stack.cpp
// Inhalt: Stack mit Push- und Pop-Funktion
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Stack.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////


/**
 * Initialisierung der Head- und Tail-Pointer
 */
Stack::Stack()
{
  head = NULL;
  tail = NULL;
}

//////////////////////////////////////////////////////////////////////////////
/**
 * Es wird neues Student-Objekt auf den Stapel gelegt und ein Stapel
 * angelegt, falls dies der erste Student sein sollte.
 */
void Stack::push(const Student& stud)
{
  // Kopie anlegen
  ListElem* neu = new ListElem;
  neu->data = stud;

  if (tail == NULL) // Stack ist leer
  {
    neu->next = NULL;
    tail = neu;
  }
  else // Anhängen
  {
    neu->next = head;
  }
  head = neu;
}

//////////////////////////////////////////////////////////////////////////////
/**
 * Das oberste Element wird vom Stapel genommen und
 * danach das ListenElement gelöscht, sowie der Head-Pointer aktualisiert.
 */
bool Stack::pop(Student& stud)
{
  if (head == NULL) return false;

  if (head == tail) // Es gibt nur ein Element
  {
    stud = head->data;
    delete head;
    head = NULL;
    tail = NULL;
  }
  else
  {
    ListElem* h = head;
    stud = head->data;
    head = head->next;
    delete h;
  }
  return true;
}

//////////////////////////////////////////////////////////////////////////////
/**
 * Der Stack wird ausgegeben, ohne manipuliert zu werden.
 */
void Stack::ausgabe()
{
  if (head == NULL)
  {
    cout << "Der Stack ist leer." << endl;
  }
  else
  {
    ListElem* h = head;

    while(h != NULL)
    {
      cout << h->data.name << ", MatNr. " << h->data.matNr << " geb. am "
      << h->data.gebDatum << " wohnhaft in " << h->data.adresse << endl;
      h = h->next;

    }
  }
}

//////////////////////////////////////
////Hier Implementierung einf�gen ////
//////////////////////////////////////
