//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 5: Dynamische Datenstrukturen
//
// Datei:  Stack.h
// Inhalt: Stack mit Push-, Pop- und Ausgabe-Funktion
//////////////////////////////////////////////////////////////////////////////

#ifndef STACK_H_
#define STACK_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>

using namespace std;

#include "Student.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// STRUCT DECLARATION /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// Stackstruktur
/*!
 * Eine Implementierung des Stack-Modells.
 * Bringt Methoden zum pushen und poppen mit.
 */
struct Stack
{

  /// Initialisierung der intern verwendeten Pointer
  Stack();
  /// Funktion zum Auflegen eines weiteren Elements
  void push(const Student& stud);
  /// Ausgeben des Stapelinhalts (ohne Manipulation)
  void ausgabe();
  /// Funktion zum Abnehmen des obersten Elements
  bool pop(Student& stud);

  /*!
   * Die Struktur ListElem wird gebraucht, um den Stack dynamisch zu erweitern.
   * Die Implementierung erfolgt als einfach verkettete Liste.
   */
  struct ListElem
  {
    /// data hält das eigentliche zu speichernde Objekt.
    Student data;
    /// next ist ein Pointer auf das darunter liegende ListElem-Objekt
    ListElem* next;
  };
  /// Pointer auf den Kopf des Stapels
  ListElem* head;
  /// Pointer auf das untere Ende des Stapels
  ListElem* tail;
};

#endif /*STACK_H_*/
