//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 5: Dynamische Datenstrukturen
//
// Datei:  List.cpp
// Inhalt: Liste mit Methoden
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "List.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Konstruktor mit Zeigerinitialisierung
List::List()
{
  head = NULL;
  tail = NULL;
}

//////////////////////////////////////////////////////////////////////////////
// vorne an head anf�gen
void List::enqueueHead(const Student& stud)
{
  ListElem* neu = new ListElem;
  neu->data = stud;
  if (tail == NULL) // Liste leer??
  {
    neu->next = NULL;
    neu->last = NULL;
    tail = neu;
  }
  else
  {
    neu->next = head;
    head->last = neu;
  }
  head = neu;
}

//////////////////////////////////////////////////////////////////////////////
// Element hinten abh�ngen
bool List::dequeue(Student& stud)
{
  if (head == NULL)   //Liste leer??
  {
    return false;
  }
  else if (head == tail) // Ein Element in Liste
  {
    stud = head->data;
    delete head;
    head = NULL;
    tail = NULL;
  }
  else
  {
    stud = tail->data;
    tail = tail->last;
    delete tail->next;
    tail->next = NULL;
  }
  return true;
}

//////////////////////////////////////////////////////////////////////////////
// von vorne nach hinten ausgeben
void List::ausgabevorwaerts()
{
  ListElem* cursor = head;

  if (NULL == head)
  {
    cout << "Die Liste ist leer." << endl;
    return;
  }

  while (cursor != NULL)
  {
    cout << cursor->data.name << ", MatNr. " << cursor->data.matNr << " geb. am "
    << cursor->data.gebDatum << " wohnhaft in " << cursor->data.adresse << endl;
    cursor=cursor->next;
  }
}

//////////////////////////////////////
////Hier Implementierung einf�gen ////
//////////////////////////////////////

// von hinten nach vorne ausgeben
void List::ausgabeRueckwaerts()
{
  ListElem* cursor = tail;

  if (NULL == tail)
  {
    cout << "Die Liste ist leer." << endl;
    return;
  }

  while (cursor != NULL)
  {
    cout << cursor->data.name << ", MatNr. " << cursor->data.matNr << " geb. am "
    << cursor->data.gebDatum << " wohnhaft in " << cursor->data.adresse << endl;
    cursor=cursor->last;
  }
}

/// Datenelement am Ende der Liste anhaengen
void List::enqueueTail(const Student& stud)
{
  ListElem* neu = new ListElem;
  neu->data = stud;

  if (tail == NULL) // Liste leer??
  {
    neu->next = NULL;
    neu->last = NULL;
    tail = neu;
  }
  else
  {
    neu->last = tail;
    tail->next = neu;
  }
  tail = neu;
}

/// Nach Matrikelnummer suchen und Eintrag löschen
bool List::deleteMatNr(const int matNr)
{
  ListElem* cursor = head;
  while (NULL != cursor)
  {
    if (cursor->data.matNr == matNr)
    {
    	cout << "test." << endl;
    
      if (cursor != head)
      {
        cursor->last->next = cursor->next;
        
      }
      else
      {
    	  head = cursor->next;
      }
      if (cursor != tail)
      {
        cursor->next->last = cursor->last;
      }
      else
      {
    	tail = cursor->last;
      }
      delete cursor;
      cursor = NULL;
      return true;
    }
    cursor = cursor->next;
  }

  /* Sind bis zum Ende durchgekommen.
   * Das heißt, dass es diese MatNr nicht  in der Liste gibt.
   */
  return false;
}


