//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  Cramer.cpp
// Inhalt: Cramer-Klasse
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Cramer.h"
#include "qMatrix.h"
#include "Vektor.h"
#include <cmath>

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////

Cramer::Cramer(int n)
{
  Atrans = new qMatrix(n);
}

Vektor Cramer::loese(qMatrix A, Vektor b)
{
  det = determinante(A);
  Vektor x(b.getDim());
  invertiere(A);

  for (int i=0; i < x.getDim(); ++i)
  {
    double t = 0;
    for (int k=0; k < x.getDim(); ++k)
    {
      t += Atrans->get(i, k) * b.get(k);
    }
    x.set(i, t);
  }

  return x;
}

void Cramer::invertiere(qMatrix & A)
{
  for (int i=0; i < A.getDim(); ++i)
  {
    for (int j=0; j < A.getDim(); ++j)
    {
      qMatrix unterMat = A.untermatrix(j,i);
      Atrans->set(j,i, determinante(unterMat) * ((i+j)%2 ? -1 : 1) / det);
    }
  }
  Atrans->transponiere();
}

double Cramer::determinante(qMatrix& A)
{
  if (A.getDim() == 1)  return A.get(0,0);

  double det = 0;

  for (int i=0; i < A.getDim(); ++i)
  {
    qMatrix unterMat = A.untermatrix(0,i);

    det += (i%2 ? -1 : 1) * A.get(0,i) * determinante(unterMat);
  }
  return det;
}
