//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  Gauss.cpp
// Inhalt: Gauss-Klasse
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Gauss.h"
#include <iostream>
using namespace std;

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////

Gauss::Gauss(int n)
{
  x = new Vektor(n);
}

Vektor Gauss::loese(qMatrix A, Vektor b)
{
  stufenForm(A,b);
  rueckwaertsEinsetzen(A,b);

  return *x;
}

void Gauss::stufenForm(qMatrix & A, Vektor & b)
{
  for (int i = 0; i < A.getDim(); ++i) {
    for (int j = i+1; j < A.getDim(); ++j) {
      double factor = A.get(j,i) / A.get(i,i);
      double t;

      b.set(j, b.get(j)-b.get(i)*factor);

      for (int k = 0; k < A.getDim(); ++k)
      {
        if (k > i)
        {
          t = A.get(j,k) -factor*A.get(i,k);
          A.set(j,k, t);
        }
        else
        {
          A.set(j,k, 0);
        }
      }
    }
  }
}

void Gauss::rueckwaertsEinsetzen(qMatrix & A, Vektor & b)
{
  int lastPos = A.getDim()-1;

  x->set(lastPos, b.get(lastPos) / A.get(lastPos,lastPos));

  for (int i=lastPos-1; i >= 0; --i)
  {
    double t = b.get(i);

    for (int k=i+1; k <= lastPos; ++k)
    {
      t -= A.get(i,k) * x->get(k);
    }
    t /= A.get(i,i);
    x->set(i, t);
  }
}
