//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  LR.cpp
// Inhalt: LR-Klasse
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "LR.h"
#include <iostream>
using namespace std;

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
LR::LR(int n)
{
  x = new Vektor(n);
  y = new Vektor(n);
  L = new qMatrix(n);
  R = new qMatrix(n);
}

//////////////////////////////////////////////////////////////////////////////
Vektor LR::loese(qMatrix A, Vektor b)
{
  zerlege(A);
  erzeugeLundR(A);
  vorwaertsEinsetzen(b);
  rueckwaertsEinsetzen();

  cout << *y;

  return *x;
}

//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////
////Hier Implementierung einf�gen ////
//////////////////////////////////////

// Der PseudoCode funktioniert nur, wenn nicht durch 0 dividiert wird.
void LR::zerlege(qMatrix& A)
{
  double t;
  for (int i = 0; i < A.getDim(); ++i) {
    for (int j = i+1; j < A.getDim(); ++j) {
      t = A.get(j,i) / A.get(i,i);
      A.set(j,i, t);

      for (int k = i+1; k < A.getDim(); ++k)
      {
        t = A.get(j,k) -A.get(j,i)*A.get(i,k);
        A.set(j,k, t);
      }
    }
  }
}

//////////////////////////////////////////////////////////////////////////////
// Schreibe aus der Matrix A in die Matrizen L und R
void LR::erzeugeLundR(qMatrix& A)
{
  for (int i=0; i < A.getDim(); ++i)
  {
    for (int j=0; j < A.getDim(); ++j)
    {
      if (j > i)
      {
        L->set(j,i, A.get(j,i));

      }
      else
      {
        R->set(j,i, A.get(j,i));
        if (j==i)
        {
          L->set(j,i, 1);
        }
      }
    }
  }

}

//////////////////////////////////////////////////////////////////////////////
void LR::vorwaertsEinsetzen(Vektor& b)
{
  y->set(0, b.get(0));
  for (int i=1; i < b.getDim(); ++i)
  {
    double t = b.get(i);
    for (int k=0; k < i; ++k)
    {
      t -= L->get(i,k) * y->get(k);
    }
    y->set(i, t);
  }
}

//////////////////////////////////////////////////////////////////////////////
void LR::rueckwaertsEinsetzen()
{
  int lastPos = x->getDim()-1;
  x->set(lastPos, y->get(lastPos) / R->get(lastPos, lastPos));

  for (int i=lastPos-1; i >= 0; --i)
  {
    double t = y->get(i);

    for (int k=i+1; k <= lastPos; ++k)
    {
      t -= R->get(i,k) * x->get(k);
    }

    t /= R->get(i,i);
    x->set(i, t);
  }
}














