//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: Lsung eines mathematischen Anwendungsproblems
//
// Datei:  qMatrix.cpp
// Inhalt: Matrix-Klasse zum speichern von quadratischen Matrizen variabler Gre
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "qMatrix.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Erstelle einen Array mit n^2 Inhalten, und betrachte diese als eine Matrix in der die Werte 
// Zeilenweise aneinander gereiht sind.
qMatrix::qMatrix(int n)
{
	dim = n;
	A = new double[n*n];
	for (int i = 0; i < dim; i++)
	{
		for (int j = 0; j < dim; j++)
		{
			A[i*dim+j] = 0.0;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
// Kopierkonstruktor
qMatrix::qMatrix(const qMatrix& alteMatrix)
{
	dim = alteMatrix.getDim();
	A = new double[dim*dim];
	for (int i = 0; i < dim; i++)
	{
		for (int j = 0; j < dim; j++)
		{
			A[i*dim+j] = alteMatrix.get(i,j);
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//Zuweisungsoperator
qMatrix& qMatrix::operator=(const qMatrix& B)
{
	this->dim = B.getDim();
	for (int i = 0; i < dim; i++)
	{
		for (int j = 0; j < dim; j++)
		{
			this->A[i*dim+j] = B.get(i,j);
		}
	}
	return *this;
}

//////////////////////////////////////////////////////////////////////////////
// Destruktor
qMatrix::~qMatrix()
{
	delete[] A;
}

//////////////////////////////////////////////////////////////////////////////
// Auf das Element in der i-ten Zeile und j-ten Spalte zurgreifen
double qMatrix::get(const int i, const int j) const
{
	return A[i*dim+j];
}

//////////////////////////////////////////////////////////////////////////////
// Setze Zahl an die i-te Zeile und j-te Spalte
void qMatrix::set(const int i, const int j, const double zahl)
{
	A[i*dim+j]=zahl;
}

//////////////////////////////////////////////////////////////////////////////
// Getmethode fr die Dimension (wichtig fr fast alle for-Schleifen)
int qMatrix::getDim() const
{
	return dim;
}

//////////////////////////////////////////////////////////////////////////////
// Transponiere die Matrix
void qMatrix::transponiere()
{
	double temp;
	for (int i = 0; i < dim; i++)
	{
		for (int j = i+1; j < dim; j++)
		{
			temp = A[i*dim+j];
			A[i*dim+j] = A[j*dim+i];
			A[j*dim+i] = temp;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
// Erstelle einer Matrix mit einer Spalte und Zeile weniger in der die i-te  Zeile und j-te Spalte der
// ursprnglichen Matrix fehlt und gebe diese neue Matrix zurck
qMatrix qMatrix::untermatrix(int i, int j)
{
	qMatrix untermat(this->getDim()-1);
	int n=0;
	for (int k = 0; k < this->getDim(); k++)
	{
		for (int l = 0; l < this->getDim(); l++)
		{
			if ( (i != k) && (j != l) )
			{
				untermat.A[n] = this->get(k,l);
				n++;
			}
		}
	}
	return untermat;
	
}

//////////////////////////////////////////////////////////////////////////////
// Ausgabeoperator, auerhalb der Klasse implementiert
ostream& operator<<(ostream& Stream, const qMatrix& A)
{
	for (int i = 0; i < A.getDim(); i++)
	{
		for (int j = 0; j < A.getDim(); j++)
		{
			Stream << setprecision(4) << A.get(i,j) << "\t";
		}
		Stream << endl;
	}
	Stream << endl;
    return Stream;
}
