//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 8: Sortierverfahren, Templates
//
// Datei:  Feld.cpp
// Inhalt: ArrayKlasse zur Verwaltung von Zahlen
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Feld.h"
#include <time.h>

//////////////////////////////////////////////////////////////////////////////
////////////////// Funktions-Implementierung /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
// �berladener Eingeabeoperator f�r das manuelle Auff�llen des Feldes
istream& operator>>(istream& in, Feld& obj)
{
  return obj.input(in);
}

//////////////////////////////////////////////////////////////////////////////
// Konstruktor, belegt das Feld mit Zufallszahlen
Feld::Feld()
{
  srand( (unsigned)time( NULL ) );
  for (int i = 0; i < n; i++)
    a[i] = rand()%100 +1;

  vergleiche=0;
  vertauschungen=0;
}
//////////////////////////////////////////////////////////////////////////////

istream& Feld::input(istream& in)
{
  for(int i = 0; i < n; i++)
  {
    in >> a[i];
  }
  return in;
}

//////////////////////////////////////////////////////////////////////////////
void Feld::ausgabe()
{
  for (int i = 0; i < n; i++)
    cout << a[i] << endl;

  cout << endl << "Es gab insgesamt " << vergleiche << " Vergleiche"
  << " und " << vertauschungen << " Vertauschungen." << endl;
}

//////////////////////////////////////////////////////////////////////////////
// Sortieren durch Ausw�hlen
void Feld::selectionSort()
{
  int SchleifenLaeufe = n-1;
  for(int k = 0; k < SchleifenLaeufe; k++)
  {
    // Finde kleinstes Element im unsortierten Teil
    int min = k;
    for(int i = k+1; i <= SchleifenLaeufe; i++)
    {
      ++vergleiche;
      if (a[i] < a[min]) min=i;
    }
    // Tausche kleinstes Element mit k-tem Element
    if (min != k)
    {
      ++vertauschungen;
      int temp = a[k];
      a[k] = a[min];
      a[min] = temp;
    }

  }
}

//////////////////////////////////////////////////////////////////////////////
// Sortieren durch Einf�gen
void Feld::insertionSort()
{
  int schleifenLaeufe = n-1;
  for(int k = 1; k <= schleifenLaeufe; k++)
  {
    ++vergleiche;
    if (a[k] < a[k-1])
    {
      ++vertauschungen;
      int x = a[k];
      int i = 0;
      ++vergleiche;
      for ( i = k; ( (i > 0) && (a[i-1] > x) ); i-- )
      {
        ++vertauschungen;
        a[i] = a[i-1]; // rechts schieben
      }
      a[i] = x; // einf�gen
    }
  }
}

//////////////////////////////////////////////////////////////////////////////

void Feld::bubbleSort()
{
  for (int k=n; k > 0; --k)
  {
    for (int i=0; i < k; ++i)
    {
      ++vergleiche;
      if (a[i] > a[i+1])
      {
        swap(&a[i], &a[i+1]);
      }
    }
  }
}

void Feld::swap(int * a, int * b)
{
  if (a==b) return;

  ++vertauschungen;
  *a ^= *b;
  *b ^= *a;
  *a ^= *b;
}

void Feld::quickSort()
{
  quickSort(0, n-1);
}

void Feld::quickSort(const int l, const int r)
{
  if(l >= r) return;

  int k = partition(l, r);
  quickSort(l, k);
  quickSort(k+1, r);
}

int Feld::partition(int l, int r)
{
  int m=(l+r)/2, pivot=a[m], i=l-1, k=r+1;

  while(1)
  {
    do { ++i; ++vergleiche; } while (a[i] < pivot);
    do { --k; ++vergleiche; } while (a[k] > pivot);

    if (i < k)
    {
      swap(&a[i], &a[k]);
    }
    else
    {
      return k;
    }
  }
}
