//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 8: Sortierverfahren, Templates
//
// Datei:  StackSpeicher.h
// Inhalt: generischer Stackspeicher
//////////////////////////////////////////////////////////////////////////////

#ifndef STACKSPEICHER_H_
#define STACKSPEICHER_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>
using namespace std;
//////////////////////////////////////////////////////////////////////////////
///////////////////////// CLASS DECLARATION //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// StackKlasse
template<int size, class T>
class StackSpeicher
{
public:
  StackSpeicher();
  void push (const T& e);
  void pop (T& e);

  void sort();

private:
  void quickSort(const int l, const int r);
  int partition(int l, int r);

  T space[size];
  int index;
};

//////////////////////////////////////////////////////////////////////////////
////////////////// Funktions-Implementierung /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
// Konstruktor
template <int size, class T>
StackSpeicher <size, T> :: StackSpeicher():index(-1)
{
}


//////////////////////////////////////////////////////////////////////////////
// Einf�gen
template <int size, class T>
void StackSpeicher <size, T>::push(const T& e)
{
  if (index < size)
  {
    index += 1;
    space[index] = e;
  }
}

//////////////////////////////////////////////////////////////////////////////

// Entnehmen
template<int size, class T>
void StackSpeicher<size, T>::pop(T& e)
{
  if (index >= 0)
  {
    e = space[index];
    index -= 1;
  }
}

//////////////////////////////////////////////////////////////////////////////

template <int size, class T>
void StackSpeicher<size, T>::sort()
{
  quickSort(0, size-1);
}

template <int size, class T>
void StackSpeicher<size, T>::quickSort(const int l, const int r)
{
  if(l >= r) return;

  int k = partition(l, r);
  quickSort(l, k);
  quickSort(k+1, r);
}

template <int size, class T>
int StackSpeicher<size, T>::partition(int l, int r)
{
  int m=(l+r)/2, i=l-1, k=r+1;
  T pivot=space[m];

  while(1)
  {
    do { ++i; } while (space[i] < pivot);
    do { --k; } while (space[k] > pivot);

    if (i < k)
    {
      Student temp = space[i];
      space[i] = space[k];
      space[k] = temp;
    }
    else
    {
      return k;
    }
  }
}

#endif /*STACKSPEICHER_H_*/
