#include <cstdlib>
#include <iostream>
#include <vector>
#include <time.h>
#include <fstream>

using namespace std;

// Es wird unsigned char als Datenbyte gewdhlt
// da er 8 Bit zur Verfuegung stellt und in dieser Aufgabe nicht mehr benoetigt wird
typedef unsigned char Byte;


// speichert die aktuelle Bitfolge
Byte polynom = 0;

// Entspricht dem Bindrequivalent 00011101, also dem vorgegebenen Generatorpolynom!
const Byte dividend = 29;

// Speichert den Teilerrest der Polynomdivision
Byte iTeilerrest = 0;

// Zwischenspeicher fuer den Dividend der Polynomdivision
Byte generatorPolynom = 0;

// Wert, um den der Dividend per shift nach links geschoben werden muss
Byte linksshift = 0;

Byte pruefsumme = 0;


/*
 * Polynomdivision mit Rest
 * Rueckgabewert: Rest
 */
Byte teilerrest(Byte polynom)
{
	for (linksshift=7; linksshift > 3; --linksshift)
		if (1 & (polynom >> linksshift))
			polynom ^= dividend << (linksshift-4);

	return polynom & 0x0F;
}


/*
 * CRC-Berechnung
 */
Byte berechnePruefsumme(vector<Byte> bitmuster)
{
	Byte byte=0x00, rest=0x00;

	for (unsigned int iZaehler=0; iZaehler < bitmuster.size(); ++iZaehler)
	{
		byte = bitmuster[iZaehler];
		byte ^= rest;

		rest = teilerrest(byte);
	}

	return rest;
}


/*
 * Bitmuster ausgeben
 */
void ausgabeBitmuster(vector<Byte> bitmuster)
{
	for (unsigned int j=0; j < bitmuster.size(); ++j)
	{
		// Speicherwort (1 Byte = 8 Bit) bitweise ausgeben
		for (int k=8-1; k>=0; --k)
		{
			if (bitmuster[j] & ( 1 << k ))
			{
				cout << "1";
			}
			else
			{
				cout << "0";
			}
		}
	}
}


int main(void)
{
	// Erstellen des m*-stelligen Vektors als Bitmuster
	cout <<  "Wie viele Byte soll das Bitmuster haben? m*: ";
	unsigned int m = 0;
	cin >> m;

	srand(time(0));

	//Bitmuster mit 8-Bit-Einteilung initialisieren
	vector<Byte> bitmuster;

	for(unsigned int i = 0; i < m; ++i)
	{
		Byte byte = rand() % 256;
		bitmuster.push_back( byte );
	}


	cout << "Die Pruefsumme des " << m <<"-stelligen Bitmusters ";
	ausgabeBitmuster(bitmuster);
	cout << endl << "CRC=" << (unsigned short)berechnePruefsumme(bitmuster) << endl;

	//system("PAUSE");

	return 0;
}
